/*

The NetUsage Project
http://netusage.mozdev.org/

Copyright (C) 2004, NetUsage Project
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
NetUsage ToolItem

*/


var oldpass = nuLoadPass('net:usage:bar');
var settingsChanged = false;
var ispdescs = { 'na': '' };

function Startup() {
	try {
	var upass = document.getElementById("upass");
	var uuname = document.getElementById("uuname");
	uuname.value = oldpass[1];
	upass.value = oldpass[2];

	// fill ISP selection box
	var ispa;
	var elsel = document.getElementById('selisp');
	var sel = document.getElementById('selisps');
	var elt = document.getElementById('ispsna');
	for (ispk in nuSupportedISPs) {
		var elx = elt.cloneNode(false);
		elx.value = ispk;
		elx.label = nuSupportedISPs[ispk]
		sel.appendChild(elx);
		ispa = nuFillISPInterface(ispk);
		ispdescs[ispk] = ispa.description;
	}

	loadSettings();

	// Mozilla specific
	if ('hPrefWindow' in parent) {
		parent.hPrefWindow.registerOKCallbackFunc(onOK);
	}
	} catch(e) { alert(e); }
}



function onOK() {
	var upass = document.getElementById("upass");
	var uuname = document.getElementById("uuname");
	if (oldpass[1] != uuname.value || oldpass[2] != upass.value) {
		nuSavePass('net:usage:bar', uuname.value, upass.value);
		settingsChanged = true;
	}
	if (uuname.value == '' || upass.value == '') {
		// set usage metre to disable?
	}

	saveSettings();

	if (settingsChanged) {
		try {
		// make a delay'd reload preference, allow time for mozilla 1.4's internal pref's saving
		var prefrltimer = Components.classes['@mozilla.org/timer;1'].createInstance(Components.interfaces.nsITimer);
		// TODO: get rid of this crazy hack
		prefrltimer.init({ cmpn: Components,
			observe: function (subject, topic, data) {
				// JavaScript is an odd language!!
				//var observerSvc = Components.classes["@mozilla.org/observer-service;1"].getService().QueryInterface(Component.interfaces.nsIObserverService);
				observerSvc.notifyObservers(this, 'netusage-update', 'pref');
			} }, 1000, prefrltimer.TYPE_ONE_SHOT);
		} catch (e) { alert(e) };
		var observerSvc = Components.classes["@mozilla.org/observer-service;1"].getService().QueryInterface(Components.interfaces.nsIObserverService);
	}
}

function loadSettings() {
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var el, prefstring, preftype, prefattribute, value, k;
	var prefEls = document.getElementsByAttribute("prefstring", "*")

	for(k=0; k<prefEls.length; k++) {
		el = prefEls[k];
		prefstring = el.getAttribute('prefstring');
		preftype = el.getAttribute('preftype');
		prefattribute = el.getAttribute('prefattribute') ? el.getAttribute('prefattribute') : 'value';
//el.setAttribute(el.getAttribute(prefattribute), value);
		try {
		switch(preftype) {
			case 'bool':
				value = pref.getBoolPref(prefstring);
				el.checked = value;
				break;

			case 'int':
				value = pref.getIntPref(prefstring);
				if (el.getAttribute('prefblankvalue') != undefined && value == parseInt(el.getAttribute('prefblankvalue'), 10))
					el.value = '';
				else
					el.value = value;

				break;

			case 'string':
			default:
				value = pref.getCharPref(prefstring);
				el.value = value;
				break;
		}
		//el.setAttribute(prefattribute, value);
		} catch(e) {

		}
	}
}

function saveSettings() {
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var el, prefstring, preftype, prefattribute, value, k;
	var prefEls = document.getElementsByAttribute("prefstring", "*")

	for(k=0; k<prefEls.length; k++) {
		el = prefEls[k];
		prefstring = el.getAttribute('prefstring');
		preftype = el.getAttribute('preftype');
		prefattribute = el.getAttribute('prefattribute') ? el.getAttribute('prefattribute') : 'value';
		value = (prefattribute == 'value') ? (el.value) : el.getAttribute(prefattribute); // stupid mozilla dom makes getAttribute('value') != el.value
		//alert((el.value)+' : '+el.getAttribute(prefattribute));
		switch(preftype) {
			case 'bool':
				pref.setBoolPref(prefstring, (value == 'true'));
				break;

			case 'int':
				if (el.getAttribute('prefblankvalue') != undefined && value == '')
					pref.setIntPref(prefstring, el.getAttribute('prefblankvalue'));
				else
					pref.setIntPref(prefstring, parseInt(value));
				break;

			case 'string':
			default:
				pref.setCharPref(prefstring, value);
				break;
		}
	}
}